# Bio334

This is the Renku project for the course [Bio334](https://studentservices.uzh.ch/uzh/anonym/vvz/index.html#/details/2019/004/SM/50628703) and just a note that this project was initially forked from [Laurent Gatto's course run at UC Louvain](https://renkulab.io/gitlab/laurent.gatto/wsbim1207).


## Quick Renku instructions:

1. Go to [https://renkulab.io/](https://renkulab.io/). Click on the 'Login or Sign Up' button and make yourself an account if you do not have one, either via 'Register', a 'SWITCH edu-ID' or via a GitHub account.
2. Once logged in, go to the Bio334 "project" that Mark made:
[https://renkulab.io/projects/mark.robinson/bio334_spring2020/](https://renkulab.io/projects/mark.robinson/bio334_spring2020/)
3. Near the top right, click on the button to fork the project; this should bring up a box where you can modify the name (you don't need to) and you can click on the 'Fork' button, putting you on the landing page of your (new) project.
4. Click on the environments tab, then 'New' to open a new environment. Hopefully, it shows "Docker image available"; if not, perhaps it says "Docker Image building", which is also ok (it might take a couple of minutes to build and then turn to "Docker image available"); if you get a message, ask Mark or one of the TAs and we will try and find out why. For Python or command line work, select /lab; for R work, select, /rstudio (you can always switch back and forth). Leave the number of CPUs at 0.25 and Memory at 1G. Click 'Start environment'. This may take a couple minutes to boot up.
5. Once it's loaded, 'Connect' to the environment. For "Default Environment", you can choose `/lab` or `/rstudio` for the entry point, but for the early part of the course, `/lab` is probably more convenient (but you can always go back and forth). Keep "Number of CPUs" at 0.25 and "Amount of Memory" at 1G. This should open a new browser window with a web link that looks like:  
https://renkulab.io/[snip]/bio334_spring2020-198a8763/rstudio/  
https://renkulab.io/[snip]/bio334_spring2020-198a8763/lab/  

Note: you can always go back and forth between the `/rstudio` and `/lab` environments by modifying the end of web link, e.g., if you started in /rstudio, but want to move to /lab, you can remove "rstudio", type "lab" in its place and then press enter.

Note: you can upload files from the local computer into your environment via the left tab of the /lab/ environment.


## Working with Renku

Please see [the documentation](https://renku.readthedocs.io/en/latest/) for 
more details about Renku.


## How the images were built

So, the stack to build the images that work on Renku is a bit convoluted, so here is a description of the layers of layers that are involved. This is mostly left as a memento to remind myself how I did it. If I were to do it again, it would probably be worth organizing it all into one github repo.

First, we took an image from rocker (I think Carl Boettiger is to thank for these; these were freshly built following the recent change to `R 4.0.0`) and I uploaded it to my own dockerhub, like this:

```
docker pull rockerdev/rstudio:4.0.0
docker tag rockerdev/rstudio:4.0.0 markrobinsonuzh/renku:r4.0.0
docker push markrobinsonuzh/renku:r4.0.0
```

Second, I modified the earlier Bioconductor (many things had changed due to `rockerdev/rstudio:4.0.0` using Ubuntu 20.04) and add a bunch of the bioconductor components (note: my fork of the BioC repo; ), as follows:

```
docker build -t bioconductor_docker:4.0.0 https://github.com/markrobinsonuzh/bioconductor_docker.git
docker tag bioconductor_docker:4.0.0 markrobinsonuzh/renku:r4.0.0_bioc
docker push markrobinsonuzh/renku:r4.0.0_bioc
```

Note: [markrobinsonuzh/bioconductor_docker](https://github.com/markrobinsonuzh/bioconductor_docker) is forked from [Bioconductor/bioconductor_docker](https://github.com/Bioconductor/bioconductor_docker).

Next, using Renku's previous docker builds (I'll thank Rok and Emma and Christine here, possibly others!), the tools that are needed under the hood of Renku are added:

```
docker build -t markrobinsonuzh/renku:r4.0.0_bioc_renku https://github.com/markrobinsonuzh/renkulab-docker.git\#:docker/bioc
docker push markrobinsonuzh/renku:r4.0.0_bioc_renku
```

Note: [markrobinsonuzh/renkulab-docker](https://github.com/markrobinsonuzh/renkulab-docker) is forked from [SwissDataScienceCenter/renkulab-docker](https://github.com/SwissDataScienceCenter/renkulab-docker).

And then, it's _just_ from Renku:

```
docker build -t markrobinsonuzh/renku:r4.0.0_bioc_renku_bio334ss2020 https://renkulab.io/gitlab/mark.robinson/bio334_spring2020.git
docker push markrobinsonuzh/renku:r4.0.0_bioc_renku_bio334ss2020
```

This latter one was also built within Renku's builders, so that it can be served up for our course.
